zoukankan      html  css  js  c++  java
  • 图论--网络流--最大流--POJ 1698 Alice's Chance

    Description

    Alice, a charming girl, have been dreaming of being a movie star for long. Her chances will come now, for several filmmaking companies invite her to play the chief role in their new films. Unfortunately, all these companies will start making the films at the same time, and the greedy Alice doesn't want to miss any of them!! You are asked to tell her whether she can act in all the films.

    As for a film,

    1. it will be made ONLY on some fixed days in a week, i.e., Alice can only work for the film on these days;
    2. Alice should work for it at least for specified number of days;
    3. the film MUST be finished before a prearranged deadline.


    For example, assuming a film can be made only on Monday, Wednesday and Saturday; Alice should work for the film at least for 4 days; and it must be finished within 3 weeks. In this case she can work for the film on Monday of the first week, on Monday and Saturday of the second week, and on Monday of the third week.

    Notice that on a single day Alice can work on at most ONE film.

    Input

    The first line of the input contains a single integer T (1 <= T <= 20), the number of test cases. Then T cases follow. Each test case begins with a single line containing an integer N (1 <= N <= 20), the number of films. Each of the following n lines is in the form of "F1 F2 F3 F4 F5 F6 F7 D W". Fi (1 <= i <= 7) is 1 or 0, representing whether the film can be made on the i-th day in a week (a week starts on Sunday): 1 means that the film can be made on this day, while 0 means the opposite. Both D (1 <= D <= 50) and W (1 <= W <= 50) are integers, and Alice should go to the film for D days and the film must be finished in W weeks.

    Output

    For each test case print a single line, 'Yes' if Alice can attend all the films, otherwise 'No'.

    Sample Input

    2
    2
    0 1 0 1 0 1 0 9 3
    0 1 1 1 0 0 0 6 4
    2
    0 1 0 1 0 1 0 9 4
    0 1 1 1 0 0 0 6 2
    

    Sample Output

    Yes
    No
    

    Hint

    A proper schedule for the first test case:
    
    
    
    date     Sun    Mon    Tue    Wed    Thu    Fri    Sat
    
    week1          film1  film2  film1         film1
    
    week2          film1  film2  film1         film1
    
    week3          film1  film2  film1         film1
    
    week4          film2  film2  film2
    

      构图:

    0号节点表源点S,      1-350号节点表示每一天(因为最多只有50周),然后350+1到350+N表示这N部电影. 351+N号节点是汇点.

    源点到每部电影i有边(s, i, Di).  Di表示这部电影需要拍多少天.

    每天j到汇点t有边(j, t, 1).,如果电影i能在第j天拍摄,那么从i到j有边(i,j,1).然后求最大流是否满流!

    #include<cstdio>
    #include<cstring>
    #include<queue>
    #include<algorithm>
    #include<vector>
    #define INF 1e9
    using namespace std;
    const int maxn=400+5;
     
    struct Edge
    {
        int from,to,cap,flow;
        Edge(){}
        Edge(int f,int t,int c,int fl):from(f),to(t),cap(c),flow(fl){}
    };
     
    struct Dinic
    {
        int n,m,s,t;
        vector<Edge> edges;
        vector<int> G[maxn];
        bool vis[maxn];
        int d[maxn];
        int cur[maxn];
     
        void init(int n,int s,int t)
        {
            this->n=n, this->s=s, this->t=t;
            edges.clear();
            for(int i=0;i<n;i++) G[i].clear();
        }
     
        void AddEdge(int from,int to,int cap)
        {
            edges.push_back( Edge(from,to,cap,0) );
            edges.push_back( Edge(to,from,0,0) );
            m=edges.size();
            G[from].push_back(m-2);
            G[to].push_back(m-1);
        }
     
        bool BFS()
        {
            queue<int> Q;
            memset(vis,0,sizeof(vis));
            vis[s]=true;
            d[s]=0;
            Q.push(s);
            while(!Q.empty())
            {
                int x= Q.front(); Q.pop();
                for(int i=0;i<G[x].size();++i)
                {
                    Edge& e=edges[G[x][i]];
                    if(!vis[e.to] && e.cap>e.flow)
                    {
                        vis[e.to]=true;
                        d[e.to]=d[x]+1;
                        Q.push(e.to);
                    }
                }
            }
            return vis[t];
        }
     
        int DFS(int x,int a)
        {
            if(x==t || a==0)return a;
            int flow=0,f;
            for(int& i=cur[x];i<G[x].size();++i)
            {
                Edge& e=edges[G[x][i]];
                if(d[e.to]==d[x]+1 && (f=DFS(e.to,min(a,e.cap-e.flow) ) )>0)
                {
                    e.flow +=f;
                    edges[G[x][i]^1].flow -=f;
                    flow +=f;
                    a-=f;
                    if(a==0) break;
                }
            }
            return flow;
        }
     
        int max_flow()
        {
            int ans=0;
            while(BFS())
            {
                memset(cur,0,sizeof(cur));
                ans+=DFS(s,INF);
            }
            return ans;
        }
     
    }DC;
     
    int n,day_sum;//电影数,总共需要天数
    int src,dst;
    int can[20+5][7];//can[i][j] 表示第i部电影在一周的第j+1天是否可以拍摄
    int need[20+5];
    int week[20+5];
     
    int main()
    {
        int T; scanf("%d",&T);
        while(T--)
        {
            day_sum=0;
            scanf("%d",&n);
            src=0,dst=350+n+1;
            DC.init(350+n+2,src,dst);
            for(int i=1;i<=n;i++)
            {
                for(int j=0;j<7;j++) scanf("%d",&can[i][j]);
                scanf("%d%d",&need[i],&week[i]);
                DC.AddEdge(src,350+i,need[i]);
                day_sum += need[i];
            }
            for(int i=1;i<=350;i++)//i表每一天
            {
                DC.AddEdge(i,dst,1);
                for(int j=1;j<=n;j++)if(can[j][i%7]==1 && (i-1)/7<week[j])
                {
                    DC.AddEdge(j+350,i,1);
                }
            }
            printf("%s
    ",DC.max_flow()==day_sum?"Yes":"No");
        }
        return 0;
    }
  • 相关阅读:
    【Java并发】并发笔记(一)
    【深入Java基础】排序算法(一)
    QDU-GZS and String
    牛客网36-A,B题解
    QDU-GZS与素数大法(素数筛法)
    csdn自动展开+去广告+净化剪切板+免登陆(如有侵权,立即删博)
    QDU第一届程序设计大赛——E到I题解法(非官方题解)
    Codeforces Round #529 -C- Powers Of Two(二进制拆分)
    CodeForces
    分配物资(模拟)
  • 原文地址:https://www.cnblogs.com/lunatic-talent/p/12798624.html
Copyright © 2011-2022 走看看